/******* SEGWII *******/
//    Version 1.0     //
//                    //
// By: Ara Kourchians //
/**********************/

import processing.serial.*;                                 //Import Serial libraries
Serial port;                                                

import lll.wrj4P5.*;                                        //Import Wiimote libraries
import lll.Loc.*;                                           //Import Wiimote libraries

Wrj4P5 wii;
RimokonEvent evt;

int ledCnt = 0;
boolean[] t = new boolean[4];                               //Boolean array for the LED's on the wiimote
PImage a;                                    
PImage b;
PImage c;
PFont wiifont;
int s = 0;
float wii_x_angle;                                          //Wiimote X angle (Units are in percent realtive to mg)
float wii_y_angle;                                          //Wiimote Y angle (Units are in percent realtive to mg)

void setup() 
{
  size(800,600);                                            //Set canvas size to 800 x 600    
  a = loadImage("title.png");
  b = loadImage("wiimote.png");
  c = loadImage("main.png");
  
  wiifont = loadFont("ContinuumBold-34.vlw");               //Wii font
  textFont(wiifont, 34); 
  
  wii=new Wrj4P5(this);                                     //Make a new wii
  wii.connect();                                            //Ask the user to connect the wiimote
  
  println(Serial.list());                                   //Print out possible serial ports
  port = new Serial(this, Serial.list()[1], 115200);        //Based on which port the user wishs to communicate with the segwii
}

void draw() 
{
  if (wii.isConnecting()) return;                           //Asks you to Press 1 & 2 on the wiimote to connect
  
  
  background(51);        
  image(b, 20, 50);                                         //Wiimote picture
  image(a, 170, 30);                                        //Title picture "Segwii"
  image(c, 20, 20);                                         //Loads the background
  

  fill(51);
  text((wii.rimokon.getBatteryLevel()*100), 280, 500);      //Battery Level
  
  wii_x_angle = wii.rimokon.senced.x;                       //Grabs the current X axis tilt on the wiimote
  wii_y_angle = wii.rimokon.senced.y;                       //Grabs the current Y axis tilt on the wiimote
  
  if(-0.8 >= wii_x_angle)                                   //STOP TILTING IT SO MUCH!!
  {    
    wii.rimokon.startVibrating();                           //Shake the controller! The user is asking for too much!

    t[0] = true;
    t[1] = false;
    t[2] = false;
    t[3] = false;  
    
    fill(#FF3333);
    text((wii_x_angle), 280, 280);                          //Tilt X
      
    //1
    smooth();
    fill(#1589FF);
    rect(58, 479, 6, 6);
    
    wii.rimokon.setLEDs(t);
  }
    else if(wii_x_angle > -0.8 && wii_x_angle <= -0.5)
    {
      t[0] = true;
      t[1] = true;
      t[2] = false;
      t[3] = false;  
      wii.rimokon.setLEDs(t);
      
      fill(51);
      text((wii_x_angle), 280, 280);                       //Tilt X
      
      //1
      smooth();
      fill(#1589FF);
      rect(58, 479, 6, 6);

      
      //2
      smooth();
      fill(#1589FF);
      rect(79, 479, 6, 6);

      wii.rimokon.stopVibrating();
    }
    else if(wii_x_angle > -0.5 && wii_x_angle < -0.2)
    {
      t[0] = false;
      t[1] = true;
      t[2] = false;
      t[3] = false;  
      wii.rimokon.setLEDs(t);
      
      fill(51);
      text((wii_x_angle), 280, 280);                       //Tilt X
  
      //2
      smooth();
      fill(#1589FF);
      rect(79, 479, 6, 6);

      wii.rimokon.stopVibrating();
    }
    else if(wii_x_angle >= -0.2 && wii_x_angle <=0.2)
    {
      t[0] = false;
      t[1] = true;
      t[2] = true;
      t[3] = false;  
      wii.rimokon.setLEDs(t);
      
      fill(51);
      text((wii_x_angle), 280, 280);                       //Tilt X
  
      //2
      smooth();
      fill(#1589FF);
      rect(79, 479, 6, 6);
      
      //3
      smooth();
      fill(#1589FF);
      rect(100, 479, 6, 6);
      
      wii.rimokon.stopVibrating();
    }    
    else if(wii_x_angle > 0.2 && wii_x_angle < 0.5)
    {
      t[0] = false;
      t[1] = false;
      t[2] = true;
      t[3] = false;  
      wii.rimokon.setLEDs(t);
      
      fill(51);
      text((wii_x_angle), 280, 280);                       //Tilt X
      
      //3
      smooth();
      fill(#1589FF);
      rect(100, 479, 6, 6);
      
      wii.rimokon.stopVibrating();
    } 
    else if(wii_x_angle > 0.5 && wii_x_angle < 0.8)
    {
      t[0] = false;
      t[1] = false;
      t[2] = true;
      t[3] = true;  
      wii.rimokon.setLEDs(t);
      
      fill(51);
      text((wii_x_angle), 280, 280);                      //Tilt X
  
      //3
      smooth();
      fill(#1589FF);
      rect(100, 479, 6, 6);

      //4
      smooth();
      fill(#1589FF);
      rect(121, 479, 6, 6);
      
      wii.rimokon.stopVibrating();
    }  
    else if(wii_x_angle >= 0.8)
    {    
      wii.rimokon.startVibrating();                      //Shake the controller! The user is asking for too much!
      t[0] = false;
      t[1] = false;
      t[2] = false;
      t[3] = true;  
      
      fill(#FF3333);
      text((wii_x_angle), 280, 280);                     //Tilt X
      
      //4
      smooth();
      fill(#1589FF);      
      rect(121, 479, 6, 6);
      wii.rimokon.setLEDs(t);
    } 
      
  if(-0.8 >= wii_y_angle || wii_y_angle >= 0.8)          //STOP TILTING IT SO MUCH!!
  {    
    fill(#FF3333);
    text((wii_y_angle), 280, 380);                       //Tilt Y
    wii.rimokon.startVibrating();                        //Shake the controller! The user is asking for too much!
  }
  else
  {
    fill(51);
    text((wii_y_angle), 280, 380);                       //Tilt Y
    wii.rimokon.stopVibrating();
  }

  /**** Debug ****
  print("X:");
  print(abs(wii.rimokon.senced.x));
  print("    Y:");
  print(abs(wii.rimokon.senced.y));
  print("      B:");
  print((int)wii.rimokon.getBatteryLevel()*100);
  print("      F:");
  println(frameRate);
  ***** End Debug *****/
  
  port.write((int)(wii_x_angle*1000));                   //Forward and Backward output to Segwii via Serial connection

}


/*
    So long and thanks for all the fish!
                            _ 
                          ,' \ 
                        ,'    \...-. 
                      ,'           | 
                    ,'             | 
                 _,'---    -.      `-._ 
               ,'            `".       ) 
            ,-'                 \     / 
        ,..'-                    `.  (           _ 
       (     ,--._     ,--._      `\  \        ,' |          
      ,-'   _...._\ _,.._   \      `\  )      /   \__ 
     /    ,'      ;'     `.          \/     ,/       ) 
    |    |       |         \          `.   ,'.     ,' 
    | O  :    O  |      O  |           '"--'  \   ( 
    `._  |       \         '                  |    \ 
     . --`.      _`-.___,,'                  ,'     ) 
   .-      `'--.'  `-.__,,-'                ,'   ,-' 
 ,'        '--.-'    .                  _       ( 
(                   _.`--.-        `-..' `.      `. 
 \             _,--'                  )   |   ,.--' 
  '-.......---' 'v'""".      _Y      /    `.  | 
                (_     ;----' |     (      `.,' 
                  \   /_)     '-.   _) 
                   `-'          `..' 


*/
